import java.io.IOException;
/*
 * Company administration using binary files.
 */
public class CompanyAdminBin {

  public static void main(String[] args) throws IOException {
    // Create an array of employees.
    Employee[] employeeInfo = {
        new Employee("Ole",  "Olsen",  30.00, Gender.MALE),
        new Employee("Bill", "Bailey", 40.00, Gender.MALE),
        new Employee("Liv",  "Larsen", 50.00, Gender.FEMALE)
    };

    // Create a personnel register.
    PersonnelRegister register = new PersonnelRegister(employeeInfo);

    // Create a company that uses binary files.                      (1)
    CompanyUsingBinFiles company = new CompanyUsingBinFiles(register);

    // Write employee data in the personnel register to a binary file.
    company.writeAllEmployeesToBinFile("employeeFile.bin", false);// (2)

    // Read employee data from a binary file.
    System.out.println("Reading from binary file.");
    company.readAllEmployeesFromBinFile("employeeFile.bin");      // (3)

    // Print employee data to the terminal window.
    company.printAllEmployeesToTerminalWindow();
    company.printReport();
  }
}