import java.io.IOException;
/*
 * Company administration using serialised objects on files.
 */
public class CompanyAdminObj {

  public static void main(String[] args) {
    // Create an array of different types of employees.
    Employee[] employees = {                                        // (1)
        new Employee("Ole", "Olsen", 515.00, Gender.MALE),
        new PermanentEmployee("Bill", "Bailey", 612.00, Gender.MALE),
        new PieceWorker("Liv", "Larsen", Gender.FEMALE, 25.00, 75),
        new Manager("Molly", "Malone", 950.00, Gender.FEMALE, 150.00),
        new HourlyWorker("Sally", "Sage", 120.00, Gender.FEMALE)
    };

    // Create a personnel register.
    PersonnelRegister register = new PersonnelRegister(employees);

    // Create a company that uses files with serialised objects:
    CompanyUsingObjFiles company = new CompanyUsingObjFiles(register);

    // Serialise employee data in personnel register to a file.
    company.writeAllEmployeesToObjFile("employeeFile.obj", false);  // (2a)

    // Deserialise employee data from a file.
    System.out.println("Reading serialised objects from file.");
    company.readAllEmployeesFromObjFile("employeeFile.obj");        // (2b)

    // Print employee data to the terminal window.
    company.printAllEmployeesToTerminalWindow();
    company.printReport();
  }
}