/*
 * Company administration using random access files.
 */
class CompanyAdminRandomAccess {

  public static void main(String[] args) {
    // Create an array with different types of employees.
    Employee[] employees = {
        new Employee("Ole", "Olsen", 515.00, Gender.MALE),
        new Employee("Bill", "Bailey", 612.00, Gender.MALE),
        new Employee("Liv", "Larsen", 820.00, Gender.FEMALE)
    };

    // Create a personnel register.
    PersonnelRegister register = new PersonnelRegister(employees);

    // Create a company                                                  (1a)
    CompanyUsingRandomAccess company = new CompanyUsingRandomAccess(register);
    System.out.println("Employees to be stored:");
    company.printAllEmployeesToTerminalWindow();

    // Initialise for random access.
    company.initRandomAccessFile("employeeFile.data");                // (1b)

    // Write all employees to the file.
    int numOfEmployees = register.getNumOfEmployees();
    for (int i = 0; i < numOfEmployees; i++)
      company.appendFileWithEmployee(register.getEmployee(i));        // (2)

    // Update hourly rate directly on file.
    company.registerNewHourlyRateForEmployeeOnFile(2, 100.0);         // (3)
    company.registerNewHourlyRateForEmployeeOnFile(0, 300.0);
    company.registerNewHourlyRateForEmployeeOnFile(1, 400.0);

    System.out.println("Read all employees from random access file.");
    company.readAllEmployeesFromRandomAccessFile();                   // (4)

    // Write statistics.
    company.printAllEmployeesToTerminalWindow();
    company.printReport();

    company.closeStream();                                            // (5)
  }
}