import java.io.DataInputStream;
import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class EndOfBinFile {

  public static void main(String[] args) {                        // (1)
    try {                                                         // (2)
      readFromBinFile(args[0]);                                   // (3)
    }
    catch (ArrayIndexOutOfBoundsException exception) {
      System.out.println("File name not specified on command line.");
      exception.printStackTrace();
    }
    catch (FileNotFoundException exception) {                     // (4)
      System.out.println("File not found: " + exception);
      exception.printStackTrace();
    }
    catch (IOException exception) {                               // (5)
      System.out.println("Error reading from file: " + exception);
      exception.printStackTrace();
    }
  }

  public static void readFromBinFile(String dataFileName)
                     throws IOException {                         // (6)

    FileInputStream inFileStream = null;
    DataInputStream inBinStream = null;

    try {                                                         // (7)
      inFileStream = new FileInputStream(dataFileName);           // (8)
      inBinStream = new DataInputStream(inFileStream);
      while (true) {                                              // (9)
        int i = inBinStream.readInt();                            // (10)
        System.out.println(i);
      }
    }
    catch (EOFException exception) {                              // (11)
      System.out.println("End of file.");
    }
    finally {                                                     // (12)
      if (inBinStream != null)                                    // (13)
        inBinStream.close();                                      // (14)
    }
  }
}