final class Manager extends Employee {

  // New field
  private double managerBonus;

  // Constructors
  public Manager() { /* Default value for all fields. */ }
  public Manager(String firstName, String lastName,
                 double hourlyRate, Gender gender,
                 double bonus) {
    super(firstName, lastName, hourlyRate, gender);
    managerBonus = bonus;
  }

  public String toString() {
    return super.toString() +"\ngets " +
           String.format("%.2f", managerBonus) + " as manager bonus.";
  }

  // Overrides method in the superclass Employee
  public double computeSalary(double numOfHours) {
    assert numOfHours >= 0 : "Number of hours worked must be >= 0";
    double weeklySalary = super.computeSalary(numOfHours);
    weeklySalary += managerBonus;
    return weeklySalary;
  }

  // New methods
  public void setManagerBonus(double bonus) { managerBonus = bonus; }
  public double getManagerBonus()           { return managerBonus; }
}